# VSCode extensions

## Install of Git VSCode extensions

Click on the Extension button on the left (red box below):

![Install of VSCode extensions](images-vscode/extension.png)

Install the following extensions:

![Git extension pack](images-vscode/git-extension-pack.png)

![Git Graph](images-vscode/git-graph.png)

![git flow](images-vscode/git-flow.png)


# Cloning a repository

## Closing windows

First, close all the existing windows:

![Closing windows](images-vscode/close-windows.png)

The shortcut is `Ctrl K, F`

## Cloning a repository

Click on Git extension panel:

![Extension button for Git](images-vscode/panel-1.png)

Click on the `Clone Repository`. Enter the repository address. Add your credentials:

![Cloning a repository](images-vscode/clone-repo.png)

## Git status

To check the status of your Git repository, navigate on the different sections of the Git extension window.

![Commit text box, changes list and graph](images-vscode/source-1.png)

![Commit, branches and remote list](images-vscode/source-2.png)

# Commit changes

## Looking at changes

Click on a file that you modified on the "Changes" list:


![List of changes](images-vscode/change.png)


The changes are displayed on the right panel. Le left panel shows file as it is in `HEAD`.

## Stage (`git add`)

To add the files to the index (`git add` command), click on the `+` button:

![Git add](images-vscode/stage.png)

## Commit (`git commit`)

To commit the staged files (`git commit` command), fill the text box with a commit message and click on the `Commit` button.

![Git commit](images-vscode/commit.png)

## Push (`git push`)

To push the commited files to the remote repository (`git push` command), click on the `Sync Changes` button.

![Git push](images-vscode/push.png)

## Pull (`git pull`)

To pull a repository, click on the `...` button (in red below) and click on the `Pull` button. Enter your credentials (login and password).

![Git pull](images-vscode/fetch.png)

# Conflicts

## Conflicts: warning message

In case of a conflict, the following message will show up:

![Conflict message](images-vscode/conflict-message.png)

The files in which there is a conflict will appear with a `!` symbol

![Merge message](images-vscode/merge-message.png)

## Conflicts: manual merge

To solve a conflict manually, click on the conflicted files. You will see:

![Solving conflicts manually](images-vscode/conflict-manual.png)

VSCode also provides a Merge Editor (button at the bottom right of conflicted files)

## Conflicts: merge editor

On the top-left, you will see the incoming version (from the remote). On top-right, the actual (local) one. Below, the merge result. There are buttons that allow to choose one version or merge both versions in any order.

![Conflict merge editor](images-vscode/conflict-console.png)


## Solving conflicts

When the conflict is solved, click on the `Complete Merge` button and push your changes as shown above

![Solved conflicts](images-vscode/conflict-solved.png)
